BEEM - Android XMPP - Bug #244

Messages from other party not received when chat started from Beem
02/16/2010 06:10 PM - James Blair

Status: Closed Start date: 02/16/2010
Priority: Normal Due date:

Assignee: Nikita Kozlov % Done: 80%
Category: XMPP Estimated time: 0.00 hour
Target version: 0.1.3

Affected version: hg Locale:

Description

When | start a chat from Beem, | don't receive messages from the other party, but if the other party starts a chat, it works fine.
To reproduce:

1. Start Beem and log in

2. Click on a contact to start a chat

3. Send a message (the contact will receive this)
4. Any response from the contact will not show up

| added some debug messages and re-compiled, and | believe this is what is happening:

When a chat is started with Beem, the participant passed to smack is "user@example.com", with no resource appended. When the
user replies, smack starts a new chat with the participant "user@example.com/resource". Beem strips the resource when it looks up
the existing chat, so it knows not to start a new chat. However, the problem is that smack has created two chats, and Beem has only
associated its chat object with smack's first chat object (the one created for the outgoing chat with no resource appended).

If, however, the remote user starts the chat, then only one chat object is created (for the incoming message from "
user@example.com/resource") and everything works.

| added a debugging message to BeemChatManager.ChatlListener.chatCreated that shows what's going on:

(click on contact in Beem to start chat)

D/BeemChatManager( 1103): Get chat key = user@example.com

V/BeemChatManager( 1103): chat created locally org.jivesoftware.smack.Chat@437c5090 participant user@example.com
I/ActivityManager( 570): Displayed activity com.beem.project.beem/.ui.Chat: 284 ms

(remote user sends a message)

V/BeemChatManager( 1103): chat created non-locally org.jivesoftware.smack.Chat@437f7cd0 participant user@example.com
/resource

| tested this with a locally compiled Beem from revision 673, ejabberd, and pidgin.

Related issues:
Related to Bug #243: Unable to receive messages after contact logout Closed 02/15/2010

Associated revisions

Revision 675:764eded78962 - 02/18/2010 06:34 PM - Frédéric Barthéléry
Fixes #244 #243

Revision 675:764eded78962 - 02/18/2010 06:34 PM - Da Risk
Fixes #244 #243

Revision 675:764eded78962 - 02/18/2010 06:34 PM - Da Risk
Fixes #244 #243

History

#1 - 02/16/2010 06:33 PM - Frédéric Barthéléry
- Status changed from New to Assigned

- Assignee set to Frédéric Barthéléry
| was debugging on this yesterday. It is exactly what is happening.
We should not create the Chat before sending a message to the user. (Note : if we send a message the problem doesn't appear). However | have not
figure yet how to deal properly with open chat window. For example :

e we open the chat activity for contact user@example.com
® user@example.com/res send us a message. We should display it on the open chat activity instead of displaying a notification.

#2 - 02/18/2010 07:19 PM - Frédéric Barthéléry
- Status changed from Assigned to Resolved

- % Done changed from 0 to 100

Applied in changeset r675.

#3 - 02/18/2010 08:57 PM - Jerome M.

Hello,

It seems like the bug is still present for me... i(

#4 - 02/18/2010 09:36 PM - Nikita Kozlov

jer mar wrote:
Hello,

It seems like the bug is still present for me... :(

Are you sure that you have the last repository version ?

#5 - 02/18/2010 09:52 PM - Jerome M.

well, | triple checked that, verified md5sum of built and installed packages... I'm pretty sure now...

#6 - 02/19/2010 12:23 AM - Frédéric Barthéléry
- Status changed from Resolved to Feedback
- Target version set to 0.2

- % Done changed from 100 to 80

From the r675 changeset, there is normally only one chat created.
The chat activity now create the smack Chat object only when we are sending a message first.
| cannot reproduce your bug anymore. Could you try to get a little more details on this ?

#7 - 02/20/2010 01:47 PM - Jerome M.

It seems like the problem is the same as described by James regarding the resource when creating the chat. One is created locally when sending the
first message from beem, and another one is created when replying from the other client (empathy here) Here is an extract of my logs:

I/ActivityManager( 108): Displayed activity com.beem.project.beem/.ui.Chat: 266 ms (total 266 ms)

D/BeemChatManager( 760): Get chat key = jahrome@server

D/BeemChatManager( 760): Chatorg.jivesoftware.smack.Chat@45f36048 created locally truewith jahrome@server

I/FieldContext( 198): Bundle = Bundle[{imeOptions=1073741828, packageName=com.beem.project.beem, inputType=163905, hint=Type your
message, label=, fieldNames=, fieldld=2131361809, singleLine=false}]

D/BeemChatManager( 760): Chatorg.jivesoftware.smack.Chat@45f87e60 created locally falsewith jahrome@server/Telepathy.572f9ef8
D/dalvikvm( 542): GC freed 2673 objects / 139120 bytes in 91ms

#8 - 02/20/2010 02:13 PM - Frédéric Barthéléry
Can you check the jabber log of empathy and see if empathy responds to beem with a message containing the samedi thread element. If not this
may be a bug in empathy.

#9 - 02/20/2010 02:38 PM - Jerome M.

| have troubles understanding what samedi is... could you clarify tis point ?
Empathy does not generate such logs, | tried with pidgin and it is the same issue as it appends a ressource id :

D/BeemChatManager( 949): Chatorg.jivesoftware.smack.Chat@45f9c258 created locally falsewith
jahrome@server/24c480416ba8300d08edc50a743c0b4c60f7eb95

12/18/2025 2/4


mailto:user@example.com
mailto:user@example.com
http://dev.elyzion.net/projects/beem/repository/11/revisions/675
http://dev.elyzion.net/projects/beem/repository/11/revisions/675

Hope this help

#10 - 02/20/2010 02:41 PM - Nikita Kozlov

jer mar wrote:

| have troubles understanding what samedi is... could you clarify tis point ?
Empathy does not generate such logs, | tried with pidgin and it is the same issue as it appends a ressource id :

D/BeemChatManager( 949): Chatorg.jivesoftware.smack.Chat@45f9c258 created locally falsewith
jahrome@server/24c480416ba8300d08edc50a743c0b4c60f7eb95

Hope this help

samedi is the french world for saturday.

#11 - 02/20/2010 03:11 PM - Frédéric Barthéléry

jer mar wrote:

| have troubles understanding what samedi is... could you clarify tis point ?

Sorry completion error. | was thinking about the same thread. Pidgin haver a console that can display the XMPP message exchanged with the server.
Maybe empathy got one too.

#12 - 02/20/2010 03:31 PM - Jerome M.

here is the jabber log from pidgin:

(15:28:14) jabber: Recv (278): <message xmins='jabber:client' type='chat' from="test@server/Beem'
to="jahrome@server/045539a5bf1a21e3cbd97bd34f4a22d70e71f5d1" id="K2XDV-11'><subject/><body>test
message</body><thread>iCehk5</thread><active xmins='http://jabber.org/protocol/chatstates'/></message>
(15:28:19) jabber: Sending: <message type='chat' id="purpled922a18a’ to="test@server/Beem'><composing
xmins="http://jabber.org/protocol/chatstates'/></message>

(15:28:20) jabber: Unable to find caps: nothing known about buddy

(15:28:20) jabber: Sending: <message type='chat' id="purpled922a18b' to="test@server/Beem'><active
xmins="http://jabber.org/protocol/chatstates'/><body>reply message</body></message>

(15:28:20) jabber: Sending: <message type='chat' id="purpled922a18c' to="test@server/Beem'><active
xmins='http://jabber.org/protocol/chatstates'/></message>

#13 - 02/23/2010 06:00 PM - Frédéric Barthéléry

So this is a little bug in pidgin and empathy, maybe in the libpurble.
According to the rfc3921,

The value of the <thread/> element is generated by the sender and SHOULD be copied back in any replies.

They don't answer with the thread element so smack thinks it is another chat. | will make a little patch for smack to force it to deliver the message to
the chat conversation for the same bare jid (without the resource).

#14 - 03/05/2010 05:23 AM - Frédéric Barthéléry

The bug should normally be fixed by the new asmack library with a custom patch in r696

#15 - 03/22/2010 02:15 AM - Anonymous

Same problem here. The porblem only started after the last update. Could you please offer the previous version in the Market until this issue is fixed.
The previous version was working fine for me.

Thanks.

#16 - 03/22/2010 11:10 AM - Nikita Kozlov

It's not surprising me since | make a lot of changes in chat's related classes.
| will take a look on it this afternoon.
I hope we will manage to fix this bug before the next release.

#17 - 03/22/2010 11:11 AM - Nikita Kozlov
- Status changed from Feedback to Assigned

- Assignee changed from Frédeéric Barthéléry to Nikita Kozlov
#18 - 03/22/2010 02:49 PM - Frédéric Barthéléry

You can download the older version of Beem here. You can install it with a file manager for Android or using the android sdk.
You can also try the nigtly build where the bug should be fixed : http:/dev.beem-project.com/Beem-debug.apk
Please report any change on this.

#19 - 03/31/2010 09:19 PM - Frédéric Barthéléry
- Status changed from Assigned to Resolved

- Target version changed from 0.2 to 0.1.3

#20 - 04/07/2010 02:03 AM - Frédéric Barthéléry

- Status changed from Resolved to Closed
